﻿Imports Telerik.Web.UI

Partial Class RadFilteringGeneratingCustomQuery
    Inherits System.Web.UI.Page
    Protected Sub RadFilter1_ApplyExpressions(sender As Object, e As Telerik.Web.UI.RadFilterApplyExpressionsEventArgs)
        Dim bulder As New StringBuilder()
        Dim expressionResult As New StringBuilder()
        ProcessExpressions(e.ExpressionRoot, expressionResult)
        Response.Write(expressionResult.ToString())
    End Sub

    Protected Sub ProcessExpressions(groupExpression As RadFilterGroupExpression, resultExpression As StringBuilder)
        Dim sqlQueryProvider As New RadFilterSqlQueryProvider()
        sqlQueryProvider.ProcessGroup(TryCast(groupExpression, RadFilterGroupExpression))
        Dim result As String = sqlQueryProvider.Result
        'your processing
        resultExpression.Append(result)

        For Each expression As RadFilterExpression In groupExpression.Expressions
            If TypeOf expression Is RadFilterGroupExpression Then
                ProcessExpressions(TryCast(expression, RadFilterGroupExpression), resultExpression)
            End If
        Next
    End Sub
End Class
